import os, sys
import numpy as np
import onnx
import ktc
import torch
import torch.onnx
import torch.nn as nn

onnx_output_path = '/docker_mount/pretrain_model/aishell_tdnn/epoch19_temp2.onnx'
onnx_output_path2 = '/docker_mount/pretrain_model/aishell_tdnn/epoch19.onnx'
optimized_onnx_output_path = '/docker_mount/pretrain_model/aishell_tdnn/epoch19_optimized.onnx'
edit_optimized_onnx_output_path = '/docker_mount/pretrain_model/aishell_tdnn/epoch19_optimized_edited2.onnx'
data_path = '/docker_mount/pretrain_model/aishell_tdnn/decode_output.npz'

stage = 4

if stage <= 1 :
    
    exported_m = onnx.load(onnx_output_path)

    # Optimize the exported onnx object
    result_m = ktc.onnx_optimizer.torch_exported_onnx_flow(exported_m)
    onnx.save(result_m, onnx_output_path2)

    optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(result_m, eliminate_tail=True, opt_matmul=False)
    onnx.save(optimized_m, optimized_onnx_output_path)

if stage <= 2 :

    model = onnx.load(optimized_onnx_output_path)
    node_names = 'Transpose_30'
    # node_names = 'LogSoftmax_33'
    edit_m = ktc.onnx_optimizer.cut_graph_from_nodes(model, node_names)

    optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(edit_m, eliminate_tail=True, opt_matmul=False)

    onnx.save(optimized_m, edit_optimized_onnx_output_path)


if stage <= 3 :
    km = ktc.ModelConfig(32769, "0001", "530", onnx_path=edit_optimized_onnx_output_path)

    eval_result = km.evaluate()

if stage <= 4 :

    npz = np.load(data_path)
    input_data = npz['feature_arr']
    inf_results = ktc.kneron_inference(input_data, onnx_file=edit_optimized_onnx_output_path, input_names=['input'], platform=530)

# if stage <= 5 :

#     npz = np.load(data_path)
#     input_data = npz['feature_arr']

#     # create the input mapping
#     input_data = [
#         input_data
#     ]
#     input_mapping = {"input": input_data}

#     # Quantization
#     bie_path = km.analysis(input_mapping, output_bie = None, threads = 1)

#     fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["input"])

#     compile_result = ktc.compile([km])

#     hw_results = ktc.kneron_inference(input_data, nef_file=compile_result, platform=530)

#     ktc.combine_nef(nef_path_list, output_path = "/data1/combined")

